      SUBROUTINE MESHM
C
C          .....................................................
C          .                                                   .
C          .  TOUGH2, MODULE MESHM, VERSION 1.0, MARCH 1991    .
C          .....................................................
C
C-----THIS IS THE EXECUTIVE ROUTINE FOR THE *MESHMAKER* MODULE.
C
C     IT IS CALLED WHEN DATA BLOCK "MESHM" IS PRESENT IN THE INPUT
C     FILE, AND WILL THEN PROCEED TO PERFORM INTERNAL MESH GENERATION.
C
c 7fev 05	$REAL:8
      COMMON/MMC/MM,MC
      common/ff/h1
      character*1 h1
      CHARACTER VER*5,WORD*5
      LOGICAL EX
      DIMENSION VER(6)
      SAVE ICALL,VER
      DATA VER/'RZ2D ','RZ2DL','XYZ  ','PATTY','MINC ','     '/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(/6X,'MESHM    1.0      24 MAY       1990',6X,
     X'EXECUTIVE ROUTINE FOR INTERNAL MESH GENERATION')
C
      h1=char(12)
  100 CONTINUE
      READ 1,WORD
    1 FORMAT(A5)
      DO2 K=1,6
      IF(WORD.EQ.VER(K)) GOTO(11,11,12,13,14,101),K
    2 CONTINUE
C
      PRINT 4,WORD
    4 FORMAT(' MESHMAKER HAS READ UNKNOWN BLOCK LABEL ',A5,'  ---  ',
     X'STOP EXECUTION')
      STOP
C
   11 CONTINUE
      PRINT 21,h1
   21 format(A1/
     x' ',131('*')/' *',20X,'MESHMAKER - RZ2D: GENERATE 2-D R-Z',
     X' MESH',70X,'*'/' ',131('*'))
      CALL RZ2D
      CALL WRZ2D(K)
      GOTO 100
C
   12 CONTINUE
      PRINT 22,h1
   22 format(A1/
     x' ',131('*')/' *',20X,'MESHMAKER - XYZ: GENERATE 1, 2, OR',
     X' 3-D CARTESIAN MESH',56X,'*'/' ',131('*'))
      CALL GXYZ
      GOTO 100
C
   13 CONTINUE
      GOTO 100
C
   14 CONTINUE
      MC=MC+1
      PRINT 24,h1
   24 format(A1/
     x' ',131('*')/' *',18X,'MESHMAKER - MINC: GENERATE MULTIPLE'
     X,' INTERACTING CONTINUA MESH FOR FRACTURED MEDIUM',29X,'*'/
     X' ',131('*')/)
C
      INQUIRE(FILE='MINC',EXIST=EX)
      IF(EX) GOTO 112
      PRINT 113
  113 FORMAT(' FILE *MINC* DOES NOT EXIST --- OPEN AS A NEW FILE')
      OPEN(10,FILE='MINC',STATUS='NEW')
      GOTO 120
C
  112 PRINT 114
  114 FORMAT(' FILE *MINC* EXISTS --- OPEN AS AN OLD FILE')
      OPEN(10,FILE='MINC',STATUS='OLD')
C
  120 CONTINUE
C
      CALL MINC
      GOTO 100
C
  101 CONTINUE
      PRINT 102
  102 FORMAT(/' ',131('*')//' MESH GENERATION COMPLETE --- EXIT FROM ',
     X'MODULE *MESHMAKER*'/)
      RETURN
      END
      BLOCK DATA MM
      CHARACTER NA*1,WHERE*4,TYPE*5
      COMMON/N/NA(35)
      COMMON/CH/WHERE,TYPE(6)
      COMMON/MMC/M,MC
      COMMON/W2/NSKIP,NELEMT,NLAY,PI
      DATA NA/'1','2','3','4','5','6','7','8','9',
     X'A','B','C','D','E','F','G','H','I','J','K','L','M',
     X'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DATA TYPE/'ONE-D','TWO-D','THRED','STANA','STANB','STANT'/
      DATA PI/3.14159265/
      DATA MC/0/
      END
      SUBROUTINE RZ2D
      CHARACTER SUB*5,WORD*5,NA*1
C
      COMMON/N/NA(35)
      COMMON/W1/V(2501),A(2501),D(2501),RC(2501),H(200)
      COMMON/W2/NSKIP,NELEMT,NLAY,PI
      DIMENSION SUB(4)
      SAVE ICALL,SUB
C
      DATA SUB/'RADII','EQUID','LOGAR','LAYER'/
      DATA ICALL/0/
C
      S(X)=X*(X**NLOG-1.)/(X-1.)
C
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'RZ2D     1.0      11 FEBRUARY  1992',6X,
     X'CALCULATE 2-D R-Z MESH FROM INPUT DATA')
C
      NRAD=0
      NEQU=0
      NLOG=0
      NRADC=0
      NEQUC=0
      NLOGC=0
      NINT=0
C
  204 READ 200,WORD
  200 FORMAT(A5)
C
      DO 201 K=1,4
      IF(WORD.EQ.SUB(K)) GOTO 202
  201 CONTINUE
C
      PRINT 203,WORD
  203 FORMAT(' HAVE READ UNKNOWN BLOCK LABEL ',A5,'  ---  STOP',
     X' EXECUTION')
      STOP
C
  202 GOTO(211,212,213,214),K
C
  211 CONTINUE
C-----READ A SET OF INTERFACE RADII.
      READ 220,NRAD
  220 FORMAT(I5,5X,7E10.4)
C
      NINT1=NINT+1
      NINT=NINT+NRAD
      NRADC=NRADC+NRAD
      READ 221,(RC(I),I=NINT1,NINT)
  221 FORMAT(8E10.4)
      GOTO 204
C
  212 CONTINUE
C-----READ DATA FOR GENERATING SOME EQUIDISTANT INTERFACES.
C
      READ 220,NEQU,DR
      NINT1=NINT+1
      NINT=NINT+NEQU
      NEQUC=NEQUC+NEQU
      DO 222 I=NINT1,NINT
  222 RC(I)=RC(I-1)+DR
      GOTO 204
C
  213 CONTINUE
C-----READ DATA FOR GENERATING INTERFACES WITH LOGARITHMICALLY
C     INCREASING DISTANCE.
C
      READ 220,NLOG,RLOG,DR
      NLOGC=NLOGC+NLOG
      IF(DR.EQ.0.) DR=RC(NINT)-RC(NINT-1)
C
C
      PRINT 109
  109 FORMAT(/' ***** FIND APPROPRIATE FACTOR FOR',
     X' INCREASING RADIAL DISTANCES *****')
C
      IX=0
      AM=(RLOG-RC(NINT))/DR
      AN=FLOAT(NLOG)
      XM=AM/AN
      IF(XM.EQ.1.) GOTO40
      IF(AM.GT.AN) THEN
      XL=1.
      XR=(AM+1.)**(1./AN)
      XR=MIN(XR,XM)
      ELSE
      XL=AM/(AM+1.)
      XL=MAX(XL,XM)
      XR=1.
      ENDIF
C     FIND PROPER INCREMENT FACTOR THROUGH ITERATIVE BISECTING
   41 XM=0.5*(XL+XR)
      IF(XR.GT.2.*XL) XM=SQRT(XL*XR)
      SMID=S(XM)
      IX=IX+1
C     PRINT 42,IX,XL,XR,XM,SMID,AM
   42 FORMAT(' AT ITERATION',I3,'  XL=',E20.14,'  XR=',
     XE20.14,'  XM=',E12.6,'  SMID=',E12.6,'  AM=',E12.6)
      IF(IX.GE.1000) GOTO 43
      IF(XR-XL.LE.XL*1.E-10) GOTO40
      IF(SMID.LE.AM) XL=XM
      IF(SMID.GE.AM) XR=XM
      GOTO41
C
   40 RAT=XM
C
      PRINT 30,IX,RAT
   30 FORMAT(6X,' AFTER',I4,' ITERATIONS FOUND INCREMENT FACTOR',
     X' RAT =',E14.8)
C
      DO 223 I=1,NLOG
      DR=DR*RAT
  223 RC(NINT+I)=RC(NINT+I-1)+DR
C
      NINT=NINT+NLOG
      GOTO 204
C
  214 CONTINUE
C-----COME HERE AFTER ALL NINT INTERFACES ARE ASSIGNED, AND READ
C     DATA ON LAYER THICKNESSES.
C
      READ 220,NLAY
      READ 221,(H(I),I=1,NLAY)
      DO219 I=2,NLAY
      IF(H(I).EQ.0.) H(I)=H(I-1)
  219 IF(H(I).LT.0.) H(I)=0.
      IF(H(1).LT.0.) H(1)=0.
C
C-----NOW ASSIGN ALL GEOMETRY DATA FOR A LAYER OF UNIT THICKNESS.
C
      NELEMT=NINT-1
      DO15 I=1,NELEMT
      A(I)=2.*PI*RC(I+1)
      D(I)=(RC(I+1)-RC(I))/2.
c  15 V(I)=PI*(RC(I+1)**2-RC(I)**2)
   15 v(i)=pi*(rc(i+1)+rc(i))*(rc(i+1)-rc(i))
c.....this modification made 2-11-92 to avoid "funny" multiply-add related
c     behavior on IBM RISC6000.
C
C=====PRINT ALL GEOMETRIC QUANTITIES=====
C
      PRINT 19
   19 FORMAT(//' * * * * * M E S H  G E O M E T R Y * * * * *',10X,
     X'VOLUME AND AREA ARE GIVEN FOR HEIGHT = 1 METER'//
     X' ELEM     REL           RCON           D              V      ',
     X'       A'/)
C
      DO17 I=1,NELEMT
      REL=RC(I+1)-D(I)
   17 PRINT 18,I,REL,RC(I+1),D(I),V(I),A(I)
   18 FORMAT(' ',I4,5(2X,E12.5))
C
      REWIND 4
      PRINT 20
   20 FORMAT(/' WRITE FILE *MESH* FROM INPUT DATA')
      WRITE(4,3) NELEMT,NRADC,NEQUC,NLOGC,RC(1),RC(NELEMT+1)
    3 FORMAT('ELEME --- ',4I5,F10.5,F10.3)
C
      RETURN
C
   43 CONTINUE
      PRINT 42,IX,XL,XR,XM,SMID,AM
      PRINT 44
   44 FORMAT(' CONVERGENCE FAILURE IN SUBROUTINE RZ2D'/
     X' STOP EXECUTION')
      STOP
      END
      SUBROUTINE WRZ2D(K)
      CHARACTER NA*1,NII*1,NII1*1,NOV*1,NOV1*1,DOM*5,E*5
C
      COMMON/SECPAR/E(1)
      COMMON/N/NA(35)
      COMMON/W1/V(2501),A(2501),D(2501),RC(2501),H(200)
      COMMON/W2/NSKIP,NELEMT,NLAY,PI
C
      SAVE ICALL
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'WRZ2D    1.0      26 MARCH     1991',6X,
     X'WRITE DATA FOR 2-D R-Z MESH ON FILE *MESH*')
C
      NSKIP1=1
      NSKIP2=2
C
      NII=' '
      IF(K.EQ.2) GOTO1
C
C-----COME HERE TO GENERATE MESH BY VERTICAL COLUMNS
      DO4 I=NSKIP1,NELEMT
      MI=MOD(I,100)
      II=I/100
      IF(II.GE.1) NII=NA(II)
      REL=RC(I+1)-D(I)
      ZJ=-H(1)/2.
      DO4 J=1,NLAY
      MJ=MOD(J-1,35)+1
C     MJ RUNS FROM 1 TO 35 FOR CONSECUTIVE LAYERS.
      NOV=NA((J-1)/35+10)
C     NOV RUNS THROUGH A, B, C, ... FOR THE 1ST, 2ND, 3RD, ... SET
C     OF 35 LAYERS.
      IF(J.GT.1) ZJ=ZJ-H(J)/2.-H(J-1)/2.
      AIJ=0.
      IF(J.EQ.1) AIJ=AIJ+V(I)
      IF(J.EQ.NLAY) AIJ=AIJ+V(I)
      VIJ=V(I)*H(J)
    4 WRITE(4,5) NOV,NA(MJ),NII,MI,VIJ,AIJ,REL,ZJ
C-----CONVENTION FOR ELEMENT NAMES.
C     NOV = A, B, C, .... LABELS 1ST, 2ND, 3RD, ... SET OF 35 LAYERS.
C     NA = 1, 2, 3, ... 9, A, B, C, ... LABELS LAYERS.
C     NII = 1, 2, 3, ... AFTER 100, 200, 300, ... RADIAL ELEMENTS.
C     MI = 1, 2, 3, ... 99; NUMBERS RADIAL ELEMENTS IN EXCESS OF
C          FULL HUNDREDS.
    5 FORMAT(3A1,I2,10X,'    1',2E10.4,10X,E10.4,10X,E10.4)
C
      GOTO 2
C
    1 CONTINUE
C-----COME HERE TO GENERATE MESH BY HORIZONTAL LAYERS
      ZJ=-H(1)/2.
      DO3 J=1,NLAY
      MJ=MOD(J-1,35)+1
C     MJ RUNS FROM 1 TO 35 FOR CONSECUTIVE LAYERS.
      NOV=NA((J-1)/35+10)
C     NOV RUNS THROUGH A, B, C, ... FOR THE 1ST, 2ND, 3RD, ... SET
C     OF 35 LAYERS.
      IF(J.GT.1) ZJ=ZJ-H(J)/2.-H(J-1)/2.
      DO3 I=NSKIP1,NELEMT
      MI=MOD(I,100)
      II=I/100
      IF(II.GE.1) NII=NA(II)
      REL=RC(I+1)-D(I)
      AIJ=0.
      IF(J.EQ.1) AIJ=AIJ+V(I)
      IF(J.EQ.NLAY) AIJ=AIJ+V(I)
      VIJ=V(I)*H(J)
    3 WRITE(4,5) NOV,NA(MJ),NII,MI,VIJ,AIJ,REL,ZJ
C
    2 CONTINUE
C
      WRITE(4,6)
    6 FORMAT('     ')
      WRITE(4,7)
    7 FORMAT('CONNE')
C
C-----ASSIGN HORIZONTAL CONNECTIONS.
C
      NII=' '
      NII1=' '
      DO8 I=NSKIP2,NELEMT
      MI=MOD(I,100)
      II=I/100
      IF(II.GE.1) NII=NA(II)
      MI1=MOD(I-1,100)
      II1=(I-1)/100
      IF(II1.GE.1) NII1=NA(II1)
      DO8 J=1,NLAY
      MJ=MOD(J-1,35)+1
C     MJ RUNS FROM 1 TO 35 FOR CONSECUTIVE LAYERS.
      NOV=NA((J-1)/35+10)
C     NOV RUNS THROUGH A, B, C, ... FOR THE 1ST, 2ND, 3RD, ... SET
C     OF 35 LAYERS.
C     DO8 J=1,1
      AIJ=A(I-1)*H(J)
    8 WRITE(4,9) NOV,NA(MJ),NII1,MI1,NOV,NA(MJ),NII,MI,D(I-1),D(I),
     XAIJ
    9 FORMAT(3A1,I2,3A1,I2,19X,1H1,3E10.4)
C
      IF(NLAY.LE.1) GOTO42
C
C-----NOW FOR THE VERTICAL CONNECTIONS.
C
      NII=' '
      DO40 I=NSKIP1,NELEMT
      MI=MOD(I,100)
      II=I/100
      IF(II.GE.1) NII=NA(II)
      AI=V(I)
C
      DO40 J=2,NLAY
      J1=J-1
      MJ=MOD(J-1,35)+1
      NOV=NA((J-1)/35+10)
      MJ1=MOD(J1-1,35)+1
      NOV1=NA((J1-1)/35+10)
      D1=H(J1)/2.
      D2=H(J)/2.
   40 WRITE(4,41) NOV1,NA(MJ1),NII,MI,NOV,NA(MJ),NII,MI,D1,D2,AI
   41 FORMAT(3A1,I2,3A1,I2,19X,1H3,3E10.4,2H1.)
C
   42 CONTINUE
C
      WRITE(4,6)
C
      REWIND 4
      READ(4,43) DOM
   43 FORMAT(A5)
      L=0
      DO44 I=NSKIP1,NELEMT
      DO44 J=1,NLAY
      L=L+1
   44 READ(4,43) E(L)
C
      CALL PRZ2D(K,NSKIP1,NELEMT,NLAY)
C
      RETURN
      END
      SUBROUTINE PRZ2D(KK,NSKIP1,NELEMT,NLAY)
C
C-----MAKE STRUCTURED PRINTOUT OF R-Z GRID.
C
      CHARACTER E*5
      COMMON/SECPAR/E(1)
      common/ff/h1
      character*1 h1
      SAVE ICALL
      DATA ICALL/0/
C
C     FIND LOCATION OF ELEMENT NAME WITH R-INDEX I, Z-INDEX K.
C     MESH ORGANIZED "BY COLUMNS" (KK = 1)
      NIK1(I,K)=(I-1)*NLAY+K
C     MESH ORGANIZED "BY LAYERS" (KK = 2)
      NIK2(I,K)=(K-1)*(NELEMT-NSKIP1+1)+I
C
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'PRZ2D    1.0      27 MARCH     1991',6X,
     X'MAKE STRUCTURED PRINTOUT OF 2-D R-Z MESH')
C
      NRZ=NELEMT*NLAY
      PRINT 31,h1,NELEMT,NLAY,NRZ
   31 FORMAT(A1/' ',131('*')/' *',20X,'2-D R-Z MESH WITH NR*NLAY = ',
     XI4,' *',I4,'  =',I4,' GRID BLOCKS',52X,'*'/' ',131('*'))
C
      PRINT 18,NLAY,NELEMT
   18 FORMAT(' *',129X,'*'/
     X' *',20X,'THE MESH WILL BE PRINTED AS VERTICAL SLICES',
     X66X,'*'/' *',129X,'*'/
     X' *',20X,'LAYERS GO FROM K = 1 TO K = NLAY =',I4,71X,'*'/
     X' *',129X,'*'/
     X' *',20X,'RADIAL GRID BLOCKS GO IN COLUMNS FROM I = 1 TO',
     X' I = NR =',I4,50X,'*'/
     X' *',129X,'*'/' ',131('*')/)
C
      PRINT 4
    4 FORMAT('   COLUMN I =  1     2     3     4     5     6     ',
     X'7     8     9    10    11    12    13    14    15    16    17  ',
     X'  18    19    20'/' LAYERS')
C
      DO1 K=1,NLAY
      IF(KK.EQ.1) PRINT 6,K,(E(NIK1(I,K)),I=NSKIP1,NELEMT)
      IF(KK.EQ.2) PRINT 6,K,(E(NIK2(I,K)),I=NSKIP1,NELEMT)
    1 CONTINUE
C
    6 FORMAT('  K = ',I4,2X,20(1X,A5)/(12X,20(1X,A5)))
C
      RETURN
      END
      SUBROUTINE GXYZ
C
C-----PROGRAM FOR GENERATING 3-D X-Y-Z MESHES.
C
C     GRID BLOCK DIMENSIONS ARE DX, DY, AND DZ.
C
      CHARACTER NA*1,NW*2,NXYZ*2
      CHARACTER*5 DOM,E
      COMMON/SECPAR/E(1)
      COMMON/N/NA(35)
      DIMENSION DX(2500),DY(2500),DZ(2500)
      DIMENSION D1(2),D2(2),D3(2)
      DIMENSION NW(3)
      SAVE ICALL,NW,NX,NY,NZ,PI
      DATA NW/'NX','NY','NZ'/
      DATA NX,NY,NZ/0,0,0/
      DATA PI/3.14159265/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(/6X,'GXYZ     1.0      18 MARCH     1991',6X,
     X'GENERATE 1, 2, OR 3-D CARTESIAN MESH')
C
      DOM='    1'
      REWIND 4
      READ 101,DEG
C
  103 READ 100,NXYZ,NO,DEL
  100 FORMAT(A2,3X,I5,E10.4)
      DO102 N=1,3
      IF(NXYZ.EQ.NW(N)) GOTO(111,112,113),N
  102 CONTINUE
      GOTO 120
C
  111 NX1=NX+1
      NX=NX+NO
      IF(DEL.NE.0.) GOTO 104
      READ 101,(DX(I),I=NX1,NX)
  101 FORMAT(8E10.4)
      GOTO 103
  104 DO105 I=NX1,NX
  105 DX(I)=DEL
      GOTO 103
C
  112 NY1=NY+1
      NY=NY+NO
      IF(DEL.NE.0.) GOTO 106
      READ 101,(DY(I),I=NY1,NY)
      GOTO 103
  106 DO107 I=NY1,NY
  107 DY(I)=DEL
      GOTO 103
C
  113 NZ1=NZ+1
      NZ=NZ+NO
      IF(DEL.NE.0.) GOTO 108
      READ 101,(DZ(I),I=NZ1,NZ)
      GOTO 103
  108 DO109 I=NZ1,NZ
  109 DZ(I)=DEL
      GOTO 103
C
  120 CONTINUE
      RAD=PI*DEG/180.
      BET=SIN(RAD)
      BETA=COS(RAD)
C
C-----MAKE PRINTOUT OF MESH SPECIFICATIONS.
      NN=NX*NY*NZ
      PRINT 40,NX,NY,NZ,NN,DEG
   40 FORMAT(/' GENERATE CARTESIAN MESH WITH NX*NY*NZ = ',
     XI4,' *',I4,' *',I4,'  =  ',I5,'  GRID BLOCKS'/1X,131('*')//
     X'   THE X-AXIS IS HORIZONTAL; THE Y-AXIS IS ROTATED BY ',E10.4,
     X' DEGREES AGAINST THE HORIZONTAL'//
     X'   THE GRID INCREMENTS ARE AS FOLLOWS')
      PRINT 41,NX,(NA(I),I=1,9),(DX(I),I=1,NX)
   41 FORMAT(//'   DELTA-X  (',I4,' INCREMENTS)'//13X,9(A1,10X),'10'//
     X(10X,10(1X,E10.4)))
      PRINT 42,NY,(NA(I),I=1,9),(DY(I),I=1,NY)
   42 FORMAT(//'   DELTA-Y  (',I4,' INCREMENTS)'//13X,9(A1,10X),'10'//
     X(10X,10(1X,E10.4)))
      PRINT 43,NZ,(NA(I),I=1,9),(DZ(I),I=1,NZ)
   43 FORMAT(//'   DELTA-Z  (',I4,' INCREMENTS)'//13X,9(A1,10X),'10'//
     X(10X,10(1X,E10.4)))
      PRINT 44
   44 FORMAT(/' ',131('*'))
C
      ILOOP=0
   30 CONTINUE
      ILOOP=ILOOP+1
C
      IF(ILOOP.EQ.1) WRITE(4,20)
   20 FORMAT('ELEME')
      IF(ILOOP.EQ.2) WRITE(4,21)
   21 FORMAT('CONNE')
C
      XI=DX(1)/2.
      DO1 I=1,NX
      IM=MOD(I-1,99)+1
      NOVI=(I-1)/99
      IF(I.GT.1) XI=XI+DX(I)/2.+DX(I-1)/2.
      I1=I+1
      IM1=MOD(I1-1,99)+1
      NOVI1=(I1-1)/99
      D1(1)=DX(I)/2.
      IF(I.LT.NX) D1(2)=DX(I1)/2.
C
      YJ=DY(1)/2.
      DO1 J=1,NY
      JM=MOD(J-1,35)+1
      NOVJ=(J-1)/35
      IF(J.GT.1) YJ=YJ+DY(J)/2.+DY(J-1)/2.
      J1=J+1
      JM1=MOD(J1-1,35)+1
      NOVJ1=(J1-1)/35
      D2(1)=DY(J)/2.
      IF(J.LT.NY) D2(2)=DY(J1)/2.
C
      ZK=-DZ(1)/2.
      DO1 K=1,NZ
      KM=MOD(K-1,35)+1
      NOVK=(K-1)/35
      IF(K.GT.1) ZK=ZK-DZ(K)/2.-DZ(K-1)/2.
      K1=K+1
      KM1=MOD(K1-1,35)+1
      NOVK1=(K1-1)/35
C     SET CUMULATIVE "OVERFLOW" PARAMETERS, TO START AT NA(10) = 'A'
      NOV=NOVK+((NZ-1)/35+1)*NOVJ+((NZ-1)/35+1)*((NY-1)/35+1)*NOVI+10
      NOV1=NOVK+((NZ-1)/35+1)*NOVJ+((NZ-1)/35+1)*((NY-1)/35+1)*NOVI1+10
      NOV2=NOVK+((NZ-1)/35+1)*NOVJ1+((NZ-1)/35+1)*((NY-1)/35+1)*NOVI+10
      NOV3=NOVK1+((NZ-1)/35+1)*NOVJ+((NZ-1)/35+1)*((NY-1)/35+1)*NOVI+10
      D3(1)=DZ(K)/2.
      IF(K.LT.NZ) D3(2)=DZ(K1)/2.
C
      IF(ILOOP.EQ.2) GOTO 31
      V=DX(I)*DY(J)*DZ(K)
C
      AIJ=0.
      IF(K.EQ.1.) AIJ=AIJ+DX(I)*DY(J)
      IF(K.EQ.NZ) AIJ=AIJ+DX(I)*DY(J)
      WRITE(4,10) NA(NOV),NA(KM),NA(JM),IM,DOM,V,AIJ,XI,YJ,ZK
   10 FORMAT(3A1,I2,10X,A5,2E10.4,10X,3E10.4)
      GOTO 1
   31 CONTINUE
C
      AYZ=DY(J)*DZ(K)
      AXZ=DX(I)*DZ(K)
      AXY=DX(I)*DY(J)
      IF(I.LT.NX) WRITE(4,11)
     XNA(NOV),NA(KM),NA(JM),IM,NA(NOV1),NA(KM),NA(JM),IM1,NA(1),
     XD1(1),D1(2),AYZ
      IF(J.LT.NY) WRITE(4,11)
     XNA(NOV),NA(KM),NA(JM),IM,NA(NOV2),NA(KM),NA(JM1),IM,NA(2),
     XD2(1),D2(2),AXZ,BET
      IF(K.LT.NZ) WRITE(4,11)
     XNA(NOV),NA(KM),NA(JM),IM,NA(NOV3),NA(KM1),NA(JM),IM,NA(3),
     XD3(1),D3(2),AXY,BETA
   11 FORMAT(2(3A1,I2),19X,A1,4E10.4)
C
    1 CONTINUE
      WRITE(4,22)
   22 FORMAT('     ')
      IF(ILOOP.LT.2) GOTO 30
C
      REWIND 4
      READ(4,50) DOM
   50 FORMAT(A5)
      L=0
      DO51 I=1,NX
      DO51 J=1,NY
      DO51 K=1,NZ
      L=L+1
      READ(4,50) E(L)
   51 CONTINUE
C     CALL NCAR(NX,NY,NZ)
      CALL PCAR(NX,NY,NZ)
C
      RETURN
      END
      SUBROUTINE NCAR(NX,NY,NZ)
C
C-----MAKE STRUCTURED PRINTOUT OF X-Y-Z GRID.
C
      CHARACTER E*5
      COMMON/SECPAR/E(1)
      common/ff/h1
      character*1 h1
      SAVE ICALL
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'NCAR     1.0      19 MARCH     1991',6X,
     X'MAKE STRUCTURED PRINTOUT OF CARTESIAN MESH')
C
C
      PRINT 21,h1,NX,NY,NZ
   21 format(A1/
     x' ',131('*')/' *',20X,'CARTESIAN MESH WITH NX*NY*NZ = ',
     XI4,' *',I4,' *',I4,'  GRID BLOCKS',49X,'*'/' ',131('*'))
C
      N1=NX
      N2=NY
      N3=NZ
C
      DO2 I=1,N1
      PRINT 3,I
    3 FORMAT(/' SLICE WITH I =',I4/)
      PRINT 4
    4 FORMAT(' COLUMN J =    1     2     3     4     5     6     7  ',
     X'   8     9    10    11    12    13    14    15    16    17  ',
     X'  18    19    20'/'   ROWS')
      DO5 K=1,N3
      NLOC=(I-1)*NY*NZ+(K-1)
      PRINT 6,K,(E(NLOC+1+(J-1)*NZ),J=1,N2)
    6 FORMAT('  K = ',I4,2X,20(1X,A5)/(12X,20(1X,A5)))
    5 CONTINUE
    2 CONTINUE
C
      RETURN
      END
      SUBROUTINE PCAR(NX,NY,NZ)
C
C-----MAKE STRUCTURED PRINTOUT OF X-Y-Z GRID.
C
      CHARACTER E*5
      CHARACTER*1 L1,L2,L3
      CHARACTER*2 M1,M2,M3
      COMMON/SECPAR/E(1)
      common/ff/h1
      character*1 h1
      DIMENSION L1(6),L2(6),L3(6),M1(6),M2(6),M3(6)
      SAVE ICALL,L1,L2,L3,M1,M2,M3
      DATA ICALL/0/
      DATA L1/'I','I','J','J','K','K'/
      DATA L2/'J','K','I','K','I','J'/
      DATA L3/'K','J','K','I','J','I'/
      DATA M1/'NX','NX','NY','NY','NZ','NZ'/
      DATA M2/'NY','NZ','NX','NZ','NX','NY'/
      DATA M3/'NZ','NY','NZ','NX','NY','NX'/
C
C     FIND LOCATION OF ELEMENT NAME WITH X-INDEX I, Y-INDEX J,
C     AND Z-INDEX K
      NLOC(I,J,K)=(I-1)*NY*NZ+(J-1)*NZ+K
C
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'PCAR     1.0      25 MARCH     1991',6X,
     X'MAKE STRUCTURED PRINTOUT OF CARTESIAN MESH')
C
      IF(NX.LE.NY.AND.NY.LE.NZ) IC=1
      IF((NX.LE.NZ.AND.NZ.LT.NY).OR.
     X   (NX.LT.NZ.AND.NZ.LE.NY)) IC=2
      IF((NY.LE.NX.AND.NX.LT.NZ).OR.
     X   (NY.LT.NX.AND.NX.LE.NZ)) IC=3
      IF((NY.LE.NZ.AND.NZ.LT.NX).OR.
     X   (NY.LT.NZ.AND.NZ.LE.NX)) IC=4
      IF((NZ.LE.NX.AND.NX.LT.NY).OR.
     X   (NZ.LT.NX.AND.NX.LE.NY)) IC=5
      IF((NZ.LE.NY.AND.NY.LT.NX).OR.
     X   (NZ.LT.NY.AND.NY.LE.NX)) IC=6
C
      PRINT 31,h1,NX,NY,NZ
   31 format(A1/
     x' ',131('*')/' *',20X,'CARTESIAN MESH WITH NX*NY*NZ = ',
     XI4,' *',I4,' *',I4,'  GRID BLOCKS',49X,'*'/' ',131('*'))
C
      GOTO(11,12,13,14,15,16),IC
   11 CONTINUE
      N1=NX
      N2=NY
      N3=NZ
      GOTO 17
C
   12 CONTINUE
      N1=NX
      N2=NZ
      N3=NY
      GOTO 17
C
   13 CONTINUE
      N1=NY
      N2=NX
      N3=NZ
      GOTO 17
C
   14 CONTINUE
      N1=NY
      N2=NZ
      N3=NX
      GOTO 17
C
   15 CONTINUE
      N1=NZ
      N2=NX
      N3=NY
      GOTO 17
C
   16 CONTINUE
      N1=NZ
      N2=NY
      N3=NX
      GOTO 17
C
   17 CONTINUE
      PRINT 18,L1(IC),L1(IC),M1(IC),N1
   18 FORMAT(' *',129X,'*'/
     X' *',20X,'THE MESH WILL BE PRINTED AS SLICES FOR ',A1,
     X' = 1 TO ',A1,' = ',A2,' =',I4,49X,'*')
      PRINT 19,L2(IC),L2(IC),M2(IC),N2
   19 FORMAT(' *',129X,'*'/
     X' *',20X,'IN EACH MESH SLICE, ROWS WILL GO FROM  ',A1,
     X' = 1 TO ',A1,' = ',A2,' =',I4,49X,'*')
      PRINT 20,L3(IC),L3(IC),M3(IC),N3
   20 FORMAT(' *',129X,'*'/
     X' *',20X,'IN EACH ROW, COLUMNS WILL GO FROM      ',A1,
     X' = 1 TO ',A1,' = ',A2,' =',I4,49X,'*'/' *',129X,'*')
C
      DO2 I=1,N1
      PRINT 3,L1(IC),I
    3 FORMAT(' ',131('*')//' SLICE WITH ',A1,' =',I4/)
      PRINT 4,L3(IC)
    4 FORMAT('   COLUMN ',A1,' =  1     2     3     4     5     6     ',
     X'7     8     9    10    11    12    13    14    15    16    17  ',
     X'  18    19    20'/' ROWS')
      DO5 J=1,N2
C
      GOTO(21,22,23,24,25,26),IC
   21 PRINT 6,L2(IC),J,(E(NLOC(I,J,K)),K=1,N3)
      GOTO 5
   22 PRINT 6,L2(IC),J,(E(NLOC(I,K,J)),K=1,N3)
      GOTO 5
   23 PRINT 6,L2(IC),J,(E(NLOC(J,I,K)),K=1,N3)
      GOTO 5
   24 PRINT 6,L2(IC),J,(E(NLOC(K,I,J)),K=1,N3)
      GOTO 5
   25 PRINT 6,L2(IC),J,(E(NLOC(J,K,I)),K=1,N3)
      GOTO 5
   26 PRINT 6,L2(IC),J,(E(NLOC(K,J,I)),K=1,N3)
      GOTO 5
    6 FORMAT('  ',A1,' = ',I4,2X,20(1X,A5)/(12X,20(1X,A5)))
    5 CONTINUE
    2 CONTINUE
C
      RETURN
      END
      SUBROUTINE MINC
C
C-----THIS IS A MODIFIED AND ENHANCED VERSION OF PROGRAM GMINC ---
C
C-----THIS VERSION CAN ASSIGN VERTICAL CONNECTIONS BETWEEN MATRIX
C     CONTINUA (11-19-84).
C     FURTHER MODIFICATIONS (5-26-88):
C     (1) INCLUDE ELEMENT X,Y,Z-COORDINATES
C     (2) ELIMINATE "BOUNDARY ELEMENTS" FROM MINC-PROCEDURE
C
C***** GMINC WAS DEVELOPED BY KARSTEN PRUESS
C                          AT LAWRENCE BERKELEY LABORATORY. ************
C
C     THE PROGRAM GENERATES ONE-, TWO-, OR THREE-DIMENSIONAL MESHES
C     FOR FLOW SIMULATIONS IN FRACTURED POROUS MEDIA.
C
C     GMINC IMPLEMENTS THE METHOD OF
C                  MULTIPLE INTERACTING CONTINUA (MINC)
C     AS DEVELOPED BY PRUESS AND NARASIMHAN.
C
C     REFERENCES:
C
C     (1) K. PRUESS AND T.N. NARASIMHAN, A PRACTICAL METHOD FOR
C         MODELING FLUID AND HEAT FLOW IN FRACTURED POROUS MEDIA,
C         PAPER SPE-10509, PRESENTED AT THE SIXTH SPE-SYMPOSIUM ON
C         RESERVOIR SIMULATION, NEW ORLEANS, LA; (FEBRUARY 1982);
C         ALSO: SOCIETY OF PETROLEUM ENGINEERS JOURNAL, VOL. 25, NO.1,
C               PP. 14-26, 1985.
C
C     (2) K. PRUESS AND T.N. NARASIMHAN, ON FLUID RESERVES AND THE
C         PRODUCTION OF SUPERHEATED STEAM FROM FRACTURED, VAPOR-
C         DOMINATED GEOTHERMAL RESERVOIRS, J. GEOPHYS. RES. 87 (B11),
C         9329-9339, 1982.
C
C     (3) K. PRUESS AND K. KARASAKI, PROXIMITY FUNCTIONS FOR MODELING
C         FLUID AND HEAT FLOW IN RESERVOIRS WITH STOCHASTIC FRACTURE
C         DISTRIBUTIONS, PAPER PRESENTED AT EIGTH STANFORD WORKSHOP
C         ON GEOTHERMAL RESERVOIR ENGINEERING, STANFORD, CA.
C         (DECEMBER 1982).
C
C     (4) K. PRUESS, GMINC - A MESH GENERATOR FOR FLOW SIMULATIONS IN
C         FRACTURED RESERVOIRS, LAWRENCE BERKELEY LABORATORY REPORT
C         LBL-15227, 1983.
C
C***********************************************************************
C
      SAVE ICALL
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(/6X,'MINC     1.0      22 JANUARY   1990',6X,
     X'EXECUTIVE ROUTINE FOR MAKING A "SECONDARY" FRACTURED-POROUS',
     X' MEDIUM MESH')
C
C-----READ DATA ON MINC-PARTITIONING.
C
      CALL PART
C
C!!!! CALL TO GEOM INSERTED 11-19-84, TO OBTAIN ALL VOL(M) BEFORE
C     PROCESSING CONNECTIONS.
      CALL GEOM
C
C-----READ ELEMENT DATA FROM FILE *MESH* AND PROCESS SEQUENTIALLY.
      CALL MINCME
C
      RETURN
      END
      SUBROUTINE PART
C
C     LOCAL VARIABLE DENT REMOVED ******
      CHARACTER HB*1,WHERE*4,TYPE*5,NA*1,WORD*5
C     LOCAL VARIABLES E1,E2,MA1,MA2,EL1,EL2 REMOVED ******
C     CHARACTER EL*3
      CHARACTER DUAL*5
      COMMON/MINCD/J,NVOL,VOL(200),A(200),D(200)
      COMMON/PROXI/L,PAR(7)
      COMMON/EL/NEL,NELA
      COMMON/CH/WHERE,TYPE(6)
      COMMON/N/NA(35)
      COMMON/MMC/MM,MC
      DIMENSION WORD(16),DUAL(2)
      SAVE ICALL,HB,DUAL
      DATA HB/' '/
      DATA DUAL/'MMVER','MMALL'/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'PART     1.0      22 JANUARY   1990',6X,
     X'READ SPECIFICATIONS OF MINC-PARTITIONING FROM FILE *INPUT*')
C
      READ 5020,(WORD(I),I=1,16)
 5020 FORMAT(16A5)
      IF(WORD(1).EQ.'PART ') GOTO 920
C
      PRINT 901,WORD(1)
  901 FORMAT(' HAVE READ UNKNOWN BLOCK LABEL "',A5,'" IN MINC MODULE',
     X' --- STOP EXECUTION ---')
      STOP
C
  920 CONTINUE
C
C****READ DATA FOR MULTIPLE INTERACTING CONTINUA.***********************
C
C***** *J* IS THE NUMBER OF MULTIPLE INTERACTING CONTINUA.
C*
C***** *NVOL* (.LE.J) IS THE NUMBER OF EXPLICITLY SPECIFIED VOLUME
C*     FRACTIONS.
C*
C***** *WHERE* SPECIFIES WHETHER EXPLICITLY PROVIDED VOLUME FRACTIONS
C     ARE GIVEN STARTING AT THE OUTSIDE (FRACTURE) OR INSIDE (MATRIX).
C*
C***** *PAR* IS AN ARRAY WITH PARAMETERS FOR SPECIFYING FRACTURE
C*     DISTRIBUTIONS.
C
      DO902 L=1,6
      IF(WORD(2).EQ.TYPE(L)) GOTO 903
  902 CONTINUE
      PRINT 904,WORD(2)
  904 FORMAT(51H HAVE READ UNKNOWN PROXIMITY FUNCTION IDENTIFIER  *,A5,2
     A2H* ---   STOP EXECUTION)
      STOP
C
  903 CONTINUE
C-----INDEX *L* LABELS THE TYPE OF PROXIMITY FUNCTION SELECTED.
C
C
      READ 1,J,NVOL,WHERE,(PAR(I),I=1,7)
    1 FORMAT(2I3,A4,7E10.4)
C
C-----READ A SET OF VOLUME FRACTIONS-----
      IF(WHERE.EQ.'OUT ') READ 2,(VOL(M),M=1,NVOL)
      IF(WHERE.EQ.'IN  ') READ 2,(VOL(J+1-M),M=1,NVOL)
    2 FORMAT(8E10.4)
C
C----- END OF MINC-DATA ------------------------------------------------
C
      IF((L.EQ.2 .OR. L.EQ.3) .AND. PAR(2).EQ.0.) PAR(2)=PAR(1)
      IF(L.EQ.3 .AND. PAR(3).EQ.0.) PAR(3)=PAR(2)
C
C-----IDENTIFY CHOICE MADE FOR GLOBAL MATRIX-MATRIX FLOW.
C
      DO802 MM=1,2
      IF(WORD(4).EQ.DUAL(MM)) GOTO 803
  802 CONTINUE
      MM=0
C
  803 CONTINUE
      PRINT 801,WORD(4)
  801 FORMAT(/' CHOICE OF MATRIX-MATRIX FLOW HANDLING: "',A5,'"')
      PRINT 804
  804 FORMAT(/'                       THE OPTIONS ARE: "     "',
     X' (DEFAULT), NO GLOBAL MATRIX-MATRIX FLOW; GLOBAL FLOW ONLY',
     X' THROUGH FRACTURES'/
     X40X,'"MMVER", GLOBAL MATRIX-MATRIX FLOW IN VERTICAL DIRECTION',
     X' ONLY'/
     X40X,'"MMALL", GLOBAL MATRIX-MATRIX FLOW IN ALL DIRECTIONS'/)
      IF(MM.EQ.2.AND.J.NE.2) PRINT 806
  806 FORMAT(
     X' !!!!! WARNING !!!!! THE "MMALL" OPTION SHOULD ONLY',
     X' BE USED WITH TWO CONTINUA, WHERE IT AMOUNTS TO A DUAL-',
     X'PERMEABILITY TREATMENT')
C
  805 CONTINUE
      RETURN
      END
      SUBROUTINE GEOM
C
      CHARACTER WHERE*4,TYPE*5,NA*1
      DIMENSION X(200)
      COMMON/MINCD/J,NVOL,VOL(200),A(200),D(200)
      COMMON/PROXI/L,PAR(7)
      COMMON/CH/WHERE,TYPE(6)
      COMMON/N/NA(35)
      SAVE ICALL,DELTA
      DATA DELTA/1.E-8/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'GEOM     1.0       1 MAY       1991',6X,
     X'CALCULATE GEOMETRY PARAMETERS OF SECONDARY (FRACTURED-',
     X'POROUS) MESH')
C
      IF(NVOL.GE.J) GOTO3
C
C-----COME HERE TO ASSIGN EQUAL VOLUMINA TO SUBDIVISIONS WHICH HAVE NOT
C     BEEN EXPLICITLY SPECIFIED-----
C
      VEX=0.
      DO4 M=1,NVOL
      IF(WHERE.EQ.'OUT ') VEX=VEX+VOL(M)
    4 IF(WHERE.EQ.'IN  ') VEX=VEX+VOL(J+1-M)
C     VEX IS THE TOTAL EXPLICITLY ASSIGNED VOLUME FRACTION.
C
      IF(VEX.GT.1.) GOTO10
      IF(VEX.EQ.1.) GOTO 3
C
      VF=(1.-VEX)/FLOAT(J-NVOL)
C-----VF IS THE VOLUME FRACTION FOR PARTITIONS WHICH ARE NOT
C     EXPLICITLY ASSIGNED.
      NVOL1=NVOL+1
      DO5 M=NVOL1,J
      IF(WHERE.EQ.'OUT ') VOL(M)=VF
    5 IF(WHERE.EQ.'IN  ') VOL(J+1-M)=VF
      GOTO3
C
   10 CONTINUE
C-----COME HERE IF EXPLICITLY ASSIGNED VOLUMINA EXCEED 100%-----
      PRINT 11,VEX
   11 FORMAT(42H PROGRAM STOPS BECAUSE TOTAL VOLUME VEX = ,E12.5,40H > 1
     A00%  ---  NEED TO CORRECT INPUT DATA)
      STOP
C
    3 CONTINUE
C
C-----NOW FIND DISTANCES FROM FRACTURES WHICH CORRESPOND TO
C     DESIRED VOLUME FRACTIONS.
C     INDEXING STARTS AT THE OUTSIDE; I.E. *1* IS THE OUTERMOST
C     VOLUME ELEMENT, AND *J* IS THE INNERMOST ONE.
C
C-----INITIALIZE TOTAL VOLUME FRACTION.
      TVOL=0.
C
C-----FIRST INTERFACE WILL BE AT FRACTURE FACE.
      X(1)=0.
      D(1)=0.
      A(1)=(1.-VOL(1))*PROX(1.E-10)/1.E-10
C
C
C-----INITIALIZE SEARCH INTERVAL.
C
      XL=0.
      XR=VOL(2)/A(1)
C
C
      DO 30 M=2,J
C
C-----COMPUTE TOTAL FRACTION OF MATRIX VOLUME.
      TVOL=TVOL+VOL(M)/(1.-VOL(1))
      IF(M.EQ.J) TVOL=1.-1.E-9
C
      CALL INVER(TVOL,XMID,XL,XR)
C
      X(M)=XMID
C
      XMD=XMID*DELTA
      A(M)=(1.-VOL(1))*(PROX(XMID+XMD)-PROX(XMID-XMD))/(2.*XMD)
C
      D(M)=(X(M)-X(M-1))/2.
C
C-----PUT LEFT END OF NEXT ITERATION INTERVAL AT PRESENT X.
      XL=XMID
C
   30 CONTINUE
C
C
C-----COME HERE TO COMPUTE A QUASI-STEADY VALUE FOR INNERMOST
C     NODAL DISTANCE.
C
      GOTO (41,42,43,44,45,46,47,48,49,50),L
C
   41 CONTINUE
C----- ONE-D CASE.
      D(J)=(PAR(1)-2.*X(J-1))/6.
      GOTO 40
C
   42 CONTINUE
C----- TWO-D CASE.
      U=PAR(1)-2.*X(J-1)
      V=PAR(2)-2.*X(J-1)
      D(J)=U*V/(4.*(U+V))
      GOTO 40
C
   43 CONTINUE
C----- THRED CASE.
      U=PAR(1)-2*X(J-1)
      V=PAR(2)-2*X(J-1)
      W=PAR(3)-2*X(J-1)
      D(J)=3.*U*V*W/(10.*(U*V+V*W+U*W))
      GOTO 40
C
   44 CONTINUE
   45 CONTINUE
   46 CONTINUE
   47 CONTINUE
   48 CONTINUE
   49 CONTINUE
   50 CONTINUE
      D(J)=(X(J)-X(J-1))/5.
C
   40 CONTINUE
C
C-----PRINT OUT GEOMETRY DATA.
      PRINT 27
   27 FORMAT(//' ==================== GEOMETRY DATA, NORMALIZED TO',
     A' A DOMAIN OF UNIT VOLUME ========================='//)
C
      PRINT 23
   23 FORMAT(100H  CONTINUUM     IDENTIFIER       VOLUME      NODAL DIST
     AANCE      INTERFACE AREA   INTERFACE DISTANCE)
      PRINT 24
   24 FORMAT(84X,14HFROM FRACTURES/)
      PRINT 25,VOL(1),D(1)
   25 FORMAT(26H  1-FRACTURES      * *    ,2(4X,E12.5))
      PRINT 26,A(1),X(1)
   26 FORMAT(66X,E12.5,7X,E12.5)
C
      DO 100 M=2,J
      PRINT 101,M,NA(M),VOL(M),D(M)
  101 FORMAT(1H ,I2,1H-,6HMATRIX,9X,1H*,A1,1H*,8X,E12.5,4X,E12.5)
      IF(M.NE.J) PRINT 102,A(M),X(M)
  102 FORMAT(66X,E12.5,7X,E12.5)
  100 CONTINUE
C
      PRINT 103
  103 FORMAT(/1X,99('='))
C
      RETURN
      END
      FUNCTION PROX(X)
C
C-----THE PROXIMITY FUNCTION PROX(X) REPRESENTS THE FRACTION OF
C     MATRIX VOLUME [VM=(1.-VOL(1))*V0 WITHIN A DOMAIN V0] WHICH
C     IS WITHIN A DISTANCE X FROM THE FRACTURES.
C
      COMMON/PROXI/L,PAR(7)
      SAVE ICALL,A,B,C,D
C     NOW ASSIGN DATA FOR STANFORD LARGE RESERVOIR MODEL.
      DATA A,B,C,D/.263398,.190754,.2032,.191262/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'PROX     1.0      22 JANUARY   1990',6X,
     X'CALCULATE PROXIMITY FUNCTIONS FOR DIFFERENT MATRIX',
     X' BLOCK SHAPES')
C
      GOTO(1,2,3,4,4,4,1,1,1,1),L
C
    1 CONTINUE
C----- ONE-D CASE.
      PROX=2.*X/PAR(1)
      IF(X.GE.PAR(1)/2.) PROX=1.
      RETURN
C
    2 CONTINUE
C----- TWO-D CASE.
C     THE MATRIX BLOCKS HAVE THICKNESS OF PAR(1) AND PAR(2),
C     RESPECTIVELY, MEASURED PERPENDICULAR TO THE FRACTURES.
C     THE PROXIMITY FUNCTION IS VALID FOR ARBITRARY ANGLE
C     BETWEEN THE FRACTURE SETS.
      PROX=2.*(PAR(1)+PAR(2))*X/(PAR(1)*PAR(2))
     A-4.*X*X/(PAR(1)*PAR(2))
      IF(X.GE.PAR(1)/2. .OR. X.GE.PAR(2)/2.) PROX=1.
      RETURN
C
    3 CONTINUE
C----- THREE DIMENSIONAL CASE.
      U=2.*X/PAR(1)
      V=2.*X/PAR(2)
      W=2.*X/PAR(3)
      PROX=U*V*W-(U*V+U*W+V*W)+U+V+W
      IF(U.GE.1. .OR. V.GE.1. .OR. W.GE.1.) PROX=1.
      RETURN
C
    4 CONTINUE
C***** MATRIX OF STANFORD LARGE RESERVOIR MODEL *****
C
C
C     RECTANGULAR BLOCKS IN LAYERS B1,B2,M1,M2,T1.
      VR=8.*X**3-(8.*B+4.*A)*X**2+(4.*A*B+2.*B**2)*X
      IF(X.GE.B/2.) VR=A*B*B
C
C     TRIANGULAR BLOCKS IN LAYERS B1,B2,M1,M2,T1.
      VT=(6.+4.*SQRT(2.))*X**3
     A-(A*(6.+4.*SQRT(2.))/2.+2.*B*(2.+SQRT(2.)))*X**2
     B+(A*B*(2.+SQRT(2.))+B*B)*X
      IF(X.GE.B/(2.+SQRT(2.))) VT=A*B*B/2.
C
C     RECTANGULAR BLOCKS IN LAYER T2.
      VRT2=8.*X**3-(8.*D+4.*C)*X**2+(4.*C*D+2.*D**2)*X
      IF(X.GE.D/2.) VRT2=C*D*D
C
C     TRIANGULAR BLOCKS IN LAYER T2.
      VTT2=(6.+4.*SQRT(2.))*X**3
     A-(C*(6.+4.*SQRT(2.))/2.+2.*D*(2.+SQRT(2.)))*X**2
     B+(C*D*(2.+SQRT(2.))+D*D)*X
      IF(X.GE.D/(2.+SQRT(2.))) VTT2=C*D*D/2.
C
      IF(L.EQ.4) GOTO 14
      IF(L.EQ.5) GOTO 15
      IF(L.EQ.6) GOTO 16
C
C***** NOW COMPUTE TOTAL MATRIX VOLUME WITHIN DISTANCE X.
   14 V=5.*(5.*VR+4.*VT)+5.*VRT2+4.*VTT2
C-----AVERAGE PROXIMITY FUNCTION FOR ENTIRE ROCK LOADING.
C
      VTOT=35.*A*B**2+7.*C*D**2
C     VOLUME FRACTION.
      PROX=V/VTOT
      RETURN
C
   15 PROX=(5.*VR+4.*VT)/(7.*A*B*B)
C-----PROXIMITY FUNCTION FOR FIVE BOTTOM LAYERS.
      RETURN
C
   16 PROX=(5.*VRT2+4.*VTT2)/(7.*C*D*D)
C-----PROXIMITY FUNCTION FOR TOP LAYER.
      RETURN
C
C
      END
      SUBROUTINE INVER(F,X,XL,XR)
C
C===== THIS ROUTINE INVERTS THE PROXIMITY FUNCTION, TO GIVE A
C     DISTANCE *X* FROM FRACTURE FACES FOR A DESIRED FRACTION *F* OF
C     MATRIX VOLUME.
C
      SAVE ICALL,TOL
      DATA TOL/1.E-10/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'INVER    1.0      22 JANUARY   1990',6X,
     X'INVERT A MONOTONIC FUNCTION THROUGH NESTED BISECTIONS')
C
C-----CHECK AND ADJUST UPPER LIMIT OF SEARCH INTERVAL.
   22 FR=PROX(XR)
      IF(FR.GT.F) GOTO 20
      XR=2.*XR
      GOTO 22
C
C-----PERFORM ITERATIVE BISECTING, TO OBTAIN A SEQUENCE OF NESTED
C     INTERVALS CONTAINING THE DESIRED POINT, X.
   20 XMID=(XR+XL)/2.
      IF(XR-XL.LE.TOL*XR) GOTO 21
      FMID=PROX(XMID)
      IF(FMID.LE.F) XL=XMID
      IF(FMID.GE.F) XR=XMID
      GOTO 20
C
   21 CONTINUE
C-----COME HERE FOR CONVERGENCE.
      X=XMID
      RETURN
      END
      SUBROUTINE MINCME
C
C=====THIS ROUTINE WORKS SEQUENTIALLY THROUGH THE ELEMENTS OF THE
C     PRIMARY MESH, ASSIGNING ALL SECONDARY ELEMENTS AND INTRA-BLOCK
C     CONNECTIONS.
C
C     LOCAL VARIABLE HM REMOVED *********
      CHARACTER HB*1,H1*1,WHERE*4,TYPE*5,NA*1,DENT*5
      CHARACTER EL1*1,EL2*4,EM1*1,EM2*4,EL10*1
      CHARACTER ELEM*5,ELEM1*5,ELEM2*5,ELE*5,EC1*5,EC2*5
      COMMON/E1/ELEM(1)
      COMMON/E2/MATX(1)
      COMMON/E3/EVOL(1)
      COMMON/AHTRAN/AHT(1)
C
C$$$$$$$$$ COMMON BLOCKS FOR CONNECTIONS $$$$$$$$$$$$$$$$$$$$$$$$$$$C
C
      COMMON/C1/NEX1(1)
      COMMON/C2/NEX2(1)
      COMMON/C3/DEL1(1)
      COMMON/C4/DEL2(1)
      COMMON/C5/AREA(1)
      COMMON/C6/BETA(1)
      COMMON/C7/ISOX(1)
      COMMON/C8/GLO(1)
      COMMON/C9/ELEM1(1)
      COMMON/C10/ELEM2(1)
C
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      COMMON/MINCD/J,NVOL,VOL(200),A(200),D(200)
      COMMON/PROXI/L,PAR(7)
      COMMON/NN/NEL,NCON,NOGN,NK,NEQ,NPH,NB,NK1,NEQ1,NBK,NSEC,NFLUX
      COMMON/NP/NELP,NELAP,NCONP
      COMMON/BC/NELA
      COMMON/CH/WHERE,TYPE(6)
      COMMON/N/NA(35)
      COMMON/MMC/MM,MC
      DIMENSION DENT(16)
      SAVE ICALL,HB,H1
      DATA HB,H1/' ','1'/
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(11,899)
  899 FORMAT(6X,'MINCME   1.0      14 FEBRUARY  1990',6X,
     X'PROCESS PRIMARY MESH FROM FILE *MESH*, AND WRITE',
     X' SECONDARY MESH ON FILE *MINC*')
C
      REWIND 4
      REWIND 10
      WRITE(10,6)
    6 FORMAT('ELEME')
C
      PRINT 2
    2 FORMAT(/' READ PRIMARY MESH FROM FILE *MESH*')
C
C*****READ ELEMENT DATA FROM FILE *MESH*.*******************************
      READ(4,1) (DENT(I),I=1,16)
    1 FORMAT(16A5)
      IF(DENT(1).EQ.'ELEME') GOTO 3
      PRINT 4,DENT(1)
    4 FORMAT(' HAVE READ UNKNOWN BLOCK LABEL "',A5,'" ON FILE *MESH*',
     X' --- STOP EXECUTION ---')
      STOP
C
    3 CONTINUE
C
      NEL=0
      NELA=0
    9 READ(4,10) EL1,EL2,MA,VOLX,AHTX,X,Y,Z
   10 FORMAT(A1,A4,10X,I5,E10.4,E10.4,10X,3E10.4)
      IF(EL1.EQ.' '.AND.EL2.EQ.'    ') GOTO40
      NEL=NEL+1
      IF(VOLX.LE.0..AND.NELA.EQ.0) NELA=NEL-1
      IF(NEL.GT.NELA.AND.NELA.NE.0) GOTO 8
C-----COME HERE FOR ACTIVE ELEMENTS
      ELE=HB//EL2
      V=VOL(1)*VOLX
      MA1=MA+1
      AH=AHTX
      IF(MM.EQ.1) AH=VOL(1)*AHTX
      WRITE(10,7) ELE,MA1,V,AH,X,Y,Z
    7 FORMAT(A5,10X,I5,2E10.4,10X,3E10.4)
C     STORE FRACTURE ELEMENT NAME FOR LATER CROSS REFERENCING
      ELEM(NEL)=ELE
C
C-----FOR EACH PRIMARY ELEMENT, ASSIGN *J* SECONDARY ELEMENTS.
      DO11 M=2,J
      ELE=NA(M)//EL2
      V=VOL(M)*VOLX
      MA2=MA+2
      AH=0.
      IF(MM.EQ.1) AH=VOL(M)*AHTX
      WRITE(10,7) ELE,MA2,V,AH,X,Y,Z
C
   11 CONTINUE
C
      GOTO 9
    8 CONTINUE
C-----COME HERE FOR INACTIVE ELEMENTS. THEY WILL NOT BE SUBJECTED TO
C     THE MINC PROCEDURE, BUT WILL BE HANDLED AS A SINGLE CONTINUUM.
      ELE=EL1//EL2
      WRITE(10,7) ELE,MA,VOLX,AHTX,X,Y,Z
C
      GOTO9
C
   40 CONTINUE
C
      WRITE(10,103)
  103 FORMAT('     ')
      WRITE(10,104)
  104 FORMAT('CONNE')
C
C-----NOW REDEFINE ELEMENT COUNTERS.
      NBC=0
      IF(NELA.NE.0) NBC=NEL-NELA
      IF(NELA.EQ.0) NELA=NEL
C     PARAMETERS FOR PRIMARY MESH
      NELP=NEL
      NELAP=NELA
C     PARAMETERS FOR SECONDARY MESH
      NELA=J*NELA
      NEL=NELA+NBC
C
C*****READ CONNECTION DATA.*********************************************
C
      N=0
      NCONP=0
      READ(4,1) DENT(1)
      IF(DENT(1).EQ.'CONNE') GOTO 1200
      PRINT 1201,DENT(1)
 1201 FORMAT(' HAVE READ UNKNOWN BLOCK LABEL "',A5,'" ON FILE *MESH*',
     X' --- STOP EXECUTION ---')
      STOP
C
 1200 CONTINUE
      READ(4,20) EL1,EL2,EM1,EM2,ISOT,D1,D2,AREAX,BETAX
   20 FORMAT(2(A1,A4),15X,I5,4E10.4)
      IF(EL1.EQ.' '.AND.EL2.EQ.'    ') GOTO 1400
      IF(EL1.EQ.'+') GOTO1400
      N=N+1
      NCONP=NCONP+1
C
C-----NOW DETERMINE ACTIVITY STATUS OF ELEMENTS AT THIS CONNECTION.
C     ASSIGN THE "WOULD-BE" FRACTURE ELEMENTS, AND SEE WHETHER THEY
C     APPEAR IN THE LIST OF ACTIVE ELEMENTS
      EC1=HB//EL2
      EC2=HB//EM2
C     INITIALIZE ACTIVITY INDEX
      IAC=0
      N1=NELAP+1
      N2=NELAP+1
C
      DO15 I=1,NELAP
      IF(ELEM(I).NE.EC1) GOTO 16
      IAC=IAC+1
      N1=I
   16 IF(ELEM(I).NE.EC2) GOTO 17
      IAC=IAC+1
      N2=I
   17 CONTINUE
      IF(IAC.EQ.2) GOTO 18
   15 CONTINUE
C
      IF(N1.GT.NELAP) EC1=EL1//EL2
      IF(N2.GT.NELAP) EC2=EM1//EM2
   18 CONTINUE
C
C-----GENERATE GLOBAL FRACTURE CONNECTION DATA.
      WRITE(10,105) EC1,EC2,ISOT,D1,D2,AREAX,BETAX
  105 FORMAT(2A5,15X,I5,4E10.4)
C
C
      IF(MM.EQ.0) GOTO 1200
C-----COME HERE FOR GLOBAL MATRIX-MATRIX FLOW CONNECTIONS.
      AB=ABS(BETAX)
      IF((AB.EQ.1.AND.MM.EQ.1).OR.MM.EQ.2) GOTO 33
      GOTO 1200
C
   33 CONTINUE
C
      IF(N1.GT.NELAP.AND.N2.GT.NELAP) GOTO 1200
C!!!! DO223 - LOOP INSERTED 11-19-84 TO ASSIGN GLOBAL CONNECTIONS
C     BETWEEN MATRIX CONTINUA.
      DO223 M=2,J
      N=N+1
      IF(MM.EQ.1) AX=AREAX*VOL(M)
      IF(MM.EQ.2) AX=AREAX
      IF(N1.LE.NELAP) EC1=NA(M)//EL2
      IF(N2.LE.NELAP) EC2=NA(M)//EM2
      WRITE(10,105) EC1,EC2,ISOT,D1,D2,AX,BETAX
C
  223 CONTINUE
C
      GOTO1200
C
C-----END OF CONNECTION DATA.-------------------------------------------
C
 1400 CONTINUE
      PRINT 5,NELP,NELAP,NCONP
    5 FORMAT('            THE PRIMARY MESH HAS',I5,' ELEMENTS (',I5,
     X' ACTIVE) AND',I5,' CONNECTIONS (INTERFACES) BETWEEN THEM')
C
C-----NOW ASSIGN INTRA-BLOCK CONNECTION DATA.
C     LOOP AGAIN OVER ELEMENTS
      REWIND 4
      READ(4,1) (DENT(I),I=1,16)
      I=0
  110 READ(4,10) EL1,EL2,MA,VOLX,AHTX
      IF(EL1.EQ.' '.AND.EL2.EQ.'    ') GOTO 111
      I=I+1
C-----FOR INACTIVE ELEMENTS, DO NOT ASSIGN INTRABLOCK CONNECTIONS
      IF(I.GT.NELAP) GOTO 111
C-----COME HERE TO ASSIGN INTRABLOCK CONNECTIONS FOR ACTIVE ELEMENTS
C     ONLY.
      EL10=HB
      BETAX=0.
      DO112 M=2,J
      N=N+1
      AREAX=VOLX*A(M-1)
      WRITE(10,102) EL10,EL2,NA(M),EL2,D(M-1),D(M),AREAX
  102 FORMAT(2(A1,A4),19X,'1',3E10.4)
      EL10=NA(M)
  112 CONTINUE
      GOTO 110
C
  111 CONTINUE
      NCON=N
      PRINT 113,NEL,NELA,NCON
  113 FORMAT(/' WRITE SECONDARY MESH ON FILE *MINC*'/
     X'          THE SECONDARY MESH HAS',I5,' ELEMENTS (',I5,' ACTIVE)',
     X' AND',I5,' CONNECTIONS (INTERFACES) BETWEEN THEM')
C
      WRITE(10,103)
      ENDFILE 10
C
      RETURN
      END
